##############################################################################
#
# Copyright (c) 2012 Nexedi SA and Contributors. All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsibility of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# guarantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is free software: you can Use, Study, Modify and Redistribute
# it under the terms of the GNU General Public License version 3, or (at your
# option) any later version, as published by the Free Software Foundation.
#
# You can also Link and Combine this program with other software covered by
# the terms of any of the Free Software licenses or any of the Open Source
# Initiative approved licenses and Convey the resulting work. Corresponding
# source of such a combination shall include the source code for all other
# software used.
#
# This program is distributed WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# See COPYING file for full licensing terms.
# See https://www.nexedi.com/licensing for rationale and options.
#
##############################################################################
from slapos.recipe.librecipe import GenericBaseRecipe

class Recipe(GenericBaseRecipe):
  """
  ipv4toipv6 tunnel configuration.
  """
  # Override in subclasses
  template_name = None

  def install(self):
    return [
      self.createExecutable(
        self.options['runner-path'],
        self.substituteTemplate(
          self.getTemplateFilename(self.template_name),
          {
            'ipv6': self.options['ipv6'],
            'ipv6_port': self.options['ipv6-port'],
            'ipv4': self.options['ipv4'],
            'ipv4_port': self.options['ipv4-port'],
            'shell_path': self.options['shell-path'],
            '6tunnel_path': self.options['6tunnel-path'],
          },
        ),
      )
    ]

class SixToFour(Recipe):
    template_name = '6to4.in'

class FourToSix(Recipe):
    template_name = '4to6.in'
