# vim: set et sts=2:
##############################################################################
#
# Copyright (c) 2011 Nexedi SA and Contributors. All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsibility of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# guarantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is free software: you can Use, Study, Modify and Redistribute
# it under the terms of the GNU General Public License version 3, or (at your
# option) any later version, as published by the Free Software Foundation.
#
# You can also Link and Combine this program with other software covered by
# the terms of any of the Free Software licenses or any of the Open Source
# Initiative approved licenses and Convey the resulting work. Corresponding
# source of such a combination shall include the source code for all other
# software used.
#
# This program is distributed WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# See COPYING file for full licensing terms.
# See https://www.nexedi.com/licensing for rationale and options.
#
##############################################################################
from slapos.recipe.librecipe import GenericBaseRecipe
from zc.buildout.easy_install import _safe_arg, script_header
import sys

template = script_header + r"""
# BEWARE: This file is operated by slapgrid
# BEWARE: It will be overwritten automatically
import socket
import sys

addr = "%(hostname)s", %(port)s

try:
  socket.create_connection(addr).close()
except (socket.error, socket.timeout):
  sys.stderr.write("%%s on %%s isn't listening\n" %% addr)
  sys.exit(127)
"""

class Recipe(GenericBaseRecipe):
  """
  Check listening port promise
  """

  def install(self):
    promise = self.createExecutable(self.options['path'], template % {
      'python': _safe_arg(sys.executable),
      'dash_S': '', # BBB buildout 1.x
      'hostname': self.options['hostname'],
      'port': self.options['port'],
      })

    return [promise]
