##############################################################################
#
# Copyright (c) 2010 Nexedi SA and Contributors. All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsibility of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# guarantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is free software: you can Use, Study, Modify and Redistribute
# it under the terms of the GNU General Public License version 3, or (at your
# option) any later version, as published by the Free Software Foundation.
#
# You can also Link and Combine this program with other software covered by
# the terms of any of the Free Software licenses or any of the Open Source
# Initiative approved licenses and Convey the resulting work. Corresponding
# source of such a combination shall include the source code for all other
# software used.
#
# This program is distributed WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# See COPYING file for full licensing terms.
# See https://www.nexedi.com/licensing for rationale and options.
#
##############################################################################
from slapos.recipe.librecipe import GenericBaseRecipe
from zc.buildout import UserError

class Recipe(GenericBaseRecipe):

  def __init__(self, buildout, name, options):
    if not options['lockfile'].endswith('.lock'):
      raise UserError('lockfile parameter must end with .lock as equeue process will add .lock suffix')
    super(Recipe, self).__init__(buildout, name, options)

  def install(self):
    args = [
      self.options['equeue-binary'],
      '--database', self.options['database'],
      '--logfile', self.options['log'],
      '--lockfile', self.options['lockfile'][:-5]
    ]

    if 'takeover-triggered-file-path' in self.options:
      args += ('--takeover-triggered-file-path',
               self.options['takeover-triggered-file-path'])

    if 'loglevel' in self.options:
      args += '--loglevel', self.options['loglevel']

    args.append(self.options['socket'])

    return self.createWrapper(self.options['wrapper'], args)
