##############################################################################
#
# Copyright (c) 2011 Nexedi SA and Contributors. All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsibility of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# guarantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is free software: you can Use, Study, Modify and Redistribute
# it under the terms of the GNU General Public License version 3, or (at your
# option) any later version, as published by the Free Software Foundation.
#
# You can also Link and Combine this program with other software covered by
# the terms of any of the Free Software licenses or any of the Open Source
# Initiative approved licenses and Convey the resulting work. Corresponding
# source of such a combination shall include the source code for all other
# software used.
#
# This program is distributed WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# See COPYING file for full licensing terms.
# See https://www.nexedi.com/licensing for rationale and options.
#
##############################################################################
from slapos.recipe.librecipe import GenericBaseRecipe

class Recipe(GenericBaseRecipe):
  """
  memcached instance configuration.

  wrapper-path -- location of the init script to generate

  binary-path -- location of the memcached command

  ip -- ip of the memcached server

  port -- port of the memcached server
  """

  def install(self):
    template_filename = self.getTemplateFilename('memcached.in')

    config = dict(
        memcached_binary=self.options['binary_path'],
        memcached_ip=self.options['ip'],
        memcached_port=self.options['port'],
        shell_path=self.options['shell-path'],
    )

    executable_path = self.createExecutable(
      self.options['wrapper_path'],
      self.substituteTemplate(self.getTemplateFilename('memcached.in'),
                              config))

    return [executable_path]
