##############################################################################
#
# Copyright (c) 2010 Nexedi SA and Contributors. All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsibility of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# guarantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is free software: you can Use, Study, Modify and Redistribute
# it under the terms of the GNU General Public License version 3, or (at your
# option) any later version, as published by the Free Software Foundation.
#
# You can also Link and Combine this program with other software covered by
# the terms of any of the Free Software licenses or any of the Open Source
# Initiative approved licenses and Convey the resulting work. Corresponding
# source of such a combination shall include the source code for all other
# software used.
#
# This program is distributed WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# See COPYING file for full licensing terms.
# See https://www.nexedi.com/licensing for rationale and options.
#
##############################################################################
import json
import os

from subprocess import check_call

from slapos.recipe.librecipe import GenericBaseRecipe

class Recipe(GenericBaseRecipe):

    def install(self):

        repolist = json.loads(self.options['repos'])
        for repo, desc in repolist.iteritems():
            absolute_path = os.path.join(self.options['base-directory'], '%s.git' % repo)
            if not os.path.exists(absolute_path):
                check_call([self.options['git-binary'], 'init',
                            '--bare', absolute_path])
                # XXX: Hardcoded path
                description_filename = os.path.join(absolute_path, 'description')
                with open(description_filename, 'w') as description_file:
                    description_file.write(desc)

        return []
