##############################################################################
#
# Copyright (c) 2010 Nexedi SA and Contributors. All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsibility of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# guarantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is free software: you can Use, Study, Modify and Redistribute
# it under the terms of the GNU General Public License version 3, or (at your
# option) any later version, as published by the Free Software Foundation.
#
# You can also Link and Combine this program with other software covered by
# the terms of any of the Free Software licenses or any of the Open Source
# Initiative approved licenses and Convey the resulting work. Corresponding
# source of such a combination shall include the source code for all other
# software used.
#
# This program is distributed WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# See COPYING file for full licensing terms.
# See https://www.nexedi.com/licensing for rationale and options.
#
##############################################################################
import os

from slapos.recipe.librecipe import GenericBaseRecipe
import six

class Recipe(GenericBaseRecipe):

  def _options(self, options):
    self.directory = options.copy()
    del self.directory['recipe']
    self.mode = int(self.directory.pop('mode', '0777'), 8)

  def install(self):
    for path in sorted(six.itervalues(self.directory)):
      if path and not os.path.isdir(path):
        os.makedirs(path, self.mode)
    # WARNING: This recipe is currently used to create directories that will
    #          contain user data  (e.g. NEO db). Such directories must never
    #          be purged by the uninstallation of a recipe.
    return []
