##############################################################################
#
# Copyright (c) 2011 Nexedi SA and Contributors. All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsibility of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# guarantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is free software: you can Use, Study, Modify and Redistribute
# it under the terms of the GNU General Public License version 3, or (at your
# option) any later version, as published by the Free Software Foundation.
#
# You can also Link and Combine this program with other software covered by
# the terms of any of the Free Software licenses or any of the Open Source
# Initiative approved licenses and Convey the resulting work. Corresponding
# source of such a combination shall include the source code for all other
# software used.
#
# This program is distributed WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# See COPYING file for full licensing terms.
# See https://www.nexedi.com/licensing for rationale and options.
#
##############################################################################

from slapos.recipe.librecipe import GenericBaseRecipe

class Recipe(GenericBaseRecipe):

  def install(self):

    # Configuration file
    config = dict(
      data_directory=self.options['data-directory'],
      ip_address=self.options['ip'],
      port=self.options['sphinx-port'],
      sql_port=self.options['sql-port'],
      searchd_log=self.options['searchd-log'],
      query_log=self.options['query-log'],
      pid=self.options['pid'],
      )
    sphinx_conf_path = self.createFile(
        self.options['configuration-file'],
        self.substituteTemplate(self.getTemplateFilename('sphinx.conf.in'),
          config)
    )

    # Create init script
    wrapper = self.createWrapper(
        self.options['wrapper'],
        (self.options['sphinx-searchd-binary'].strip(), '-c',
          sphinx_conf_path, '--nodetach'),
        )

    return [wrapper, sphinx_conf_path]
