##############################################################################
#
# Copyright (c) 2012 Nexedi SA and Contributors. All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsibility of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# guarantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is free software: you can Use, Study, Modify and Redistribute
# it under the terms of the GNU General Public License version 3, or (at your
# option) any later version, as published by the Free Software Foundation.
#
# You can also Link and Combine this program with other software covered by
# the terms of any of the Free Software licenses or any of the Open Source
# Initiative approved licenses and Convey the resulting work. Corresponding
# source of such a combination shall include the source code for all other
# software used.
#
# This program is distributed WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# See COPYING file for full licensing terms.
# See https://www.nexedi.com/licensing for rationale and options.
#
##############################################################################
import os
import re
from slapos.recipe.librecipe import GenericSlapRecipe

class Recipe(GenericSlapRecipe):
  """
    Create web checker configuration.
  """
  def _install(self):
    path_list = []
    try:
      web_checker_mail_address = self.options['mail-address']
      web_checker_smtp_host = self.options['smtp-host']
      web_checker_frontend_url = self.options['frontend-url']
    except KeyError:
      # BBB
      web_checker_mail_address = self.parameter_dict['web-checker-mail-address']
      web_checker_smtp_host = self.parameter_dict['web-checker-smtp-host']
      web_checker_frontend_url = self.parameter_dict['web-checker-frontend-url']
    web_checker_working_directory = \
      self.options['web-checker-working-directory']
    config = dict(
      web_checker_mail_address = web_checker_mail_address,
      web_checker_smtp_host = web_checker_smtp_host,
      web_checker_working_directory = web_checker_working_directory,
      frontend_url = web_checker_frontend_url,
      wget_binary_path = self.options['wget-binary-path'],
      varnishlog_binary_path = self.options['varnishlog-binary-path'],
      web_checker_log = self.options['web-checker-log'],
    )
    path_list.append(self.createFile(self.options['web-checker-config'],
      self.substituteTemplate(self.getTemplateFilename('web_checker.cfg.in'),
        config)))
    return path_list
