##############################################################################
#
# Copyright (c) 2011 Nexedi SA and Contributors. All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsibility of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# guarantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is free software: you can Use, Study, Modify and Redistribute
# it under the terms of the GNU General Public License version 3, or (at your
# option) any later version, as published by the Free Software Foundation.
#
# You can also Link and Combine this program with other software covered by
# the terms of any of the Free Software licenses or any of the Open Source
# Initiative approved licenses and Convey the resulting work. Corresponding
# source of such a combination shall include the source code for all other
# software used.
#
# This program is distributed WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# See COPYING file for full licensing terms.
# See https://www.nexedi.com/licensing for rationale and options.
#
##############################################################################
from slapos.recipe.librecipe import GenericBaseRecipe
import sys

class Recipe(GenericBaseRecipe):
  """
  kvm instance configuration.
  """
  def install(self):
    config = dict(
      vnc_ip=self.options['vnc-ip'],
      vnc_port=self.options['vnc-port'],
      boot_disk_path=self.options['boot-disk-path'],
      disk_path=self.options['data-disk-path'],
      disk_size=self.options['data-disk-size'],
      disk_type=self.options['data-disk-type'],
      mac_address=self.options['mac-address'],
      smp_count=self.options['smp-count'],
      ram_size=self.options['ram-size'],
      socket_path=self.options['socket-path'],
      pid_file_path=self.options['pid-path'],
      python_path=sys.executable,
      shell_path=self.options['shell-path'],
      qemu_path=self.options['qemu-path'],
      qemu_img_path=self.options['qemu-img-path'],
      vnc_passwd=self.options['passwd']
    )

    # Runners
    runner_path = self.createExecutable(
      self.options['runner-path'],
      self.substituteTemplate(self.getTemplateFilename('kvm_run.in'), config))

    controller_path = self.createExecutable(
      self.options['controller-path'],
      self.substituteTemplate(self.getTemplateFilename('kvm_controller_run.in'),
                              config))


    return [runner_path, controller_path]
