##############################################################################
#
# Copyright (c) 2018 Nexedi SA and Contributors. All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsibility of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# guarantees and support are strongly advised to contract a Free Software
# Service Company
#
# This program is free software: you can Use, Study, Modify and Redistribute
# it under the terms of the GNU General Public License version 3, or (at your
# option) any later version, as published by the Free Software Foundation.
#
# You can also Link and Combine this program with other software covered by
# the terms of any of the Free Software licenses or any of the Open Source
# Initiative approved licenses and Convey the resulting work. Corresponding
# source of such a combination shall include the source code for all other
# software used.
#
# This program is distributed WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
#
# See COPYING file for full licensing terms.
# See https://www.nexedi.com/licensing for rationale and options.
#
##############################################################################
from setuptools import setup, find_packages

version = '0.0.1.dev0'
name = 'slapos.test.caddy-frontend'

setup(name=name,
      version=version,
      description="Test for SlapOS' Caddy Frontend",
      maintainer="Nexedi",
      maintainer_email="info@nexedi.com",
      url="https://lab.nexedi.com/nexedi/slapos",
      packages=find_packages(),
      install_requires=[
        'slapos.core',
        'slapos.cookbook',
        'slapos.libnetworkcache',
        'erp5.util',
        'requests >= 2.20.0',  # needed for recent SSL certificate fixes
        'urllib3 >= 1.24',  # needed for recent SSL certificate fixes
        # ipaddress is patching IPAddress so IPv6 in SSL certificates
        # match works
        'ipaddress >= 1.0.22',
        'requests-toolbelt',
        'supervisor',
        # caucase needed to connect to the KeDiFa caucase
        'caucase',
        'cryptography',
        'backports.lzma',
      ],
      zip_safe=True,
      test_suite='test',
      )
